package org.springblade.enterprise.feign;

import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import javax.validation.Valid;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.tool.utils.Func;
import org.springframework.cloud.openfeign.SpringQueryMap;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import org.springblade.enterprise.entity.Project;
import org.springblade.enterprise.vo.ProjectVO;
import org.springblade.enterprise.wrapper.ProjectWrapper;
import org.springblade.enterprise.service.IProjectService;
import org.springblade.core.boot.ctrl.BladeController;
import java.util.List;
/**
 *  client
 *
 * @author lianghanqiang
 * @since 2021-03-30
 */

@AllArgsConstructor
@RestController
@RequestMapping("/feign/project")

public class ProjectClient implements IProjectClient {

    private final IProjectService projectService;

        /**
     * 详情
     */
    @Override
    @GetMapping("/detail")
    public ProjectVO detail(@SpringQueryMap Project project) {
        Project detail = projectService.getOne(Condition.getQueryWrapper(project));
        return ProjectWrapper.build().entityVO(detail);
        }

    /**
     * 查询
     */
    @Override
    @GetMapping("/list")
    public List<ProjectVO> list(@SpringQueryMap Project project) {
        return ProjectWrapper.build().listVO(projectService.list(Condition.getQueryWrapper(project)));
        }



    /**
     * 新增
     */
    @Override
    @PostMapping("/save")
    public boolean save(@Valid @RequestBody Project project) {
        return projectService.save(project);
        }

    /**
     * 修改
     */
    @Override
    @PostMapping("/update")
    public boolean update(@Valid @RequestBody Project project) {
        return projectService.updateById(project);
        }

    /**
     * 新增或修改
     */
    @Override
    @PostMapping("/submit")
    public boolean submit(@Valid @RequestBody Project project) {
        return projectService.saveOrUpdate(project);
        }


    /**
     * 删除
     */
    @Override
    @PostMapping("/remove")
    public boolean remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
        return projectService.deleteLogic(Func.toLongList(ids));
        }


}
